USING: classes.struct windows.types windows.kernel32
windows.directx.d3d9types alien.c-types ;
IN: windows.directx.d3d9caps

STRUCT: D3DVSHADERCAPS2_0
    { Caps                    DWORD }
    { DynamicFlowControlDepth INT   }
    { NumTemps                INT   }
    { StaticFlowControlDepth  INT   } ;

CONSTANT: D3DVS20CAPS_PREDICATION 1

CONSTANT: D3DVS20_MAX_DYNAMICFLOWCONTROLDEPTH  24
CONSTANT: D3DVS20_MIN_DYNAMICFLOWCONTROLDEPTH  0
CONSTANT: D3DVS20_MAX_NUMTEMPS    32
CONSTANT: D3DVS20_MIN_NUMTEMPS    12
CONSTANT: D3DVS20_MAX_STATICFLOWCONTROLDEPTH    4
CONSTANT: D3DVS20_MIN_STATICFLOWCONTROLDEPTH    1

STRUCT: D3DPSHADERCAPS2_0
    { Caps                    DWORD }
    { DynamicFlowControlDepth INT   }
    { NumTemps                INT   }
    { StaticFlowControlDepth  INT   }
    { NumInstructionSlots     INT   } ;

CONSTANT: D3DPS20CAPS_ARBITRARYSWIZZLE        1
CONSTANT: D3DPS20CAPS_GRADIENTINSTRUCTIONS    2
CONSTANT: D3DPS20CAPS_PREDICATION             4
CONSTANT: D3DPS20CAPS_NODEPENDENTREADLIMIT    8
CONSTANT: D3DPS20CAPS_NOTEXINSTRUCTIONLIMIT   16

CONSTANT: D3DPS20_MAX_DYNAMICFLOWCONTROLDEPTH    24
CONSTANT: D3DPS20_MIN_DYNAMICFLOWCONTROLDEPTH    0
CONSTANT: D3DPS20_MAX_NUMTEMPS    32
CONSTANT: D3DPS20_MIN_NUMTEMPS    12
CONSTANT: D3DPS20_MAX_STATICFLOWCONTROLDEPTH    4
CONSTANT: D3DPS20_MIN_STATICFLOWCONTROLDEPTH    0
CONSTANT: D3DPS20_MAX_NUMINSTRUCTIONSLOTS    512
CONSTANT: D3DPS20_MIN_NUMINSTRUCTIONSLOTS    96

CONSTANT: D3DMIN30SHADERINSTRUCTIONS 512
CONSTANT: D3DMAX30SHADERINSTRUCTIONS 32768

STRUCT: D3DOVERLAYCAPS
    { Caps                      UINT }
    { MaxOverlayDisplayWidth    UINT }
    { MaxOverlayDisplayHeight   UINT } ;

CONSTANT: D3DOVERLAYCAPS_FULLRANGERGB          HEX: 00000001
CONSTANT: D3DOVERLAYCAPS_LIMITEDRANGERGB       HEX: 00000002
CONSTANT: D3DOVERLAYCAPS_YCbCr_BT601           HEX: 00000004
CONSTANT: D3DOVERLAYCAPS_YCbCr_BT709           HEX: 00000008
CONSTANT: D3DOVERLAYCAPS_YCbCr_BT601_xvYCC     HEX: 00000010
CONSTANT: D3DOVERLAYCAPS_YCbCr_BT709_xvYCC     HEX: 00000020
CONSTANT: D3DOVERLAYCAPS_STRETCHX              HEX: 00000040
CONSTANT: D3DOVERLAYCAPS_STRETCHY              HEX: 00000080


STRUCT: D3DCONTENTPROTECTIONCAPS
    { Caps                      DWORD     }
    { KeyExchangeType           GUID      }
    { BufferAlignmentStart      UINT      }
    { BlockAlignmentSize        UINT      }
    { ProtectedMemorySize       ULONGLONG } ;
 
CONSTANT: D3DCPCAPS_SOFTWARE              HEX: 00000001
CONSTANT: D3DCPCAPS_HARDWARE              HEX: 00000002
CONSTANT: D3DCPCAPS_PROTECTIONALWAYSON    HEX: 00000004
CONSTANT: D3DCPCAPS_PARTIALDECRYPTION     HEX: 00000008
CONSTANT: D3DCPCAPS_CONTENTKEY            HEX: 00000010
CONSTANT: D3DCPCAPS_FRESHENSESSIONKEY     HEX: 00000020
CONSTANT: D3DCPCAPS_ENCRYPTEDREADBACK     HEX: 00000040
CONSTANT: D3DCPCAPS_ENCRYPTEDREADBACKKEY  HEX: 00000080
CONSTANT: D3DCPCAPS_SEQUENTIAL_CTR_IV     HEX: 00000100
CONSTANT: D3DCPCAPS_ENCRYPTSLICEDATAONLY  HEX: 00000200

STRUCT: D3DCAPS9
    { DeviceType                          D3DDEVTYPE        }
    { AdapterOrdinal                      UINT              }
    { Caps                                DWORD             }
    { Caps2                               DWORD             }
    { Caps3                               DWORD             }
    { PresentationIntervals               DWORD             }
    { CursorCaps                          DWORD             }
    { DevCaps                             DWORD             }
    { PrimitiveMiscCaps                   DWORD             }
    { RasterCaps                          DWORD             }
    { ZCmpCaps                            DWORD             }
    { SrcBlendCaps                        DWORD             }
    { DestBlendCaps                       DWORD             }
    { AlphaCmpCaps                        DWORD             }
    { ShadeCaps                           DWORD             }
    { TextureCaps                         DWORD             }
    { TextureFilterCaps                   DWORD             }
    { CubeTextureFilterCaps               DWORD             }
    { VolumeTextureFilterCaps             DWORD             }
    { TextureAddressCaps                  DWORD             }
    { VolumeTextureAddressCaps            DWORD             }
    { LineCaps                            DWORD             }
    { MaxTextureWidth                     DWORD             }
    { MaxTextureHeight                    DWORD             }
    { MaxVolumeExtent                     DWORD             }
    { MaxTextureRepeat                    DWORD             }
    { MaxTextureAspectRatio               DWORD             }
    { MaxAnisotropy                       DWORD             }
    { MaxVertexW                          float             }
    { GuardBandLeft                       float             }
    { GuardBandTop                        float             }
    { GuardBandRight                      float             }
    { GuardBandBottom                     float             }
    { ExtentsAdjust                       float             }
    { StencilCaps                         DWORD             }
    { FVFCaps                             DWORD             }
    { TextureOpCaps                       DWORD             }
    { MaxTextureBlendStages               DWORD             }
    { MaxSimultaneousTextures             DWORD             }
    { VertexProcessingCaps                DWORD             }
    { MaxActiveLights                     DWORD             }
    { MaxUserClipPlanes                   DWORD             }
    { MaxVertexBlendMatrices              DWORD             }
    { MaxVertexBlendMatrixIndex           DWORD             }
    { MaxPointSize                        float             }
    { MaxPrimitiveCount                   DWORD             }
    { MaxVertexIndex                      DWORD             }
    { MaxStreams                          DWORD             }
    { MaxStreamStride                     DWORD             }
    { VertexShaderVersion                 DWORD             }
    { MaxVertexShaderConst                DWORD             }
    { PixelShaderVersion                  DWORD             }
    { PixelShader1xMaxValue               float             }
    { DevCaps2                            DWORD             }
    { MaxNpatchTessellationLevel          float             }
    { Reserved5                           DWORD             }
    { MasterAdapterOrdinal                UINT              }
    { AdapterOrdinalInGroup               UINT              }
    { NumberOfAdaptersInGroup             UINT              }
    { DeclTypes                           DWORD             }
    { NumSimultaneousRTs                  DWORD             }
    { StretchRectFilterCaps               DWORD             }
    { VS20Caps                            D3DVSHADERCAPS2_0 }
    { PS20Caps                            D3DPSHADERCAPS2_0 }
    { VertexTextureFilterCaps             DWORD             }
    { MaxVShaderInstructionsExecuted      DWORD             }
    { MaxPShaderInstructionsExecuted      DWORD             }
    { MaxVertexShader30InstructionSlots   DWORD             }
    { MaxPixelShader30InstructionSlots    DWORD             } ;

CONSTANT: D3DCAPS_OVERLAY                 HEX: 00000800
CONSTANT: D3DCAPS_READ_SCANLINE           HEX: 00020000

CONSTANT: D3DCAPS2_FULLSCREENGAMMA        HEX: 00020000
CONSTANT: D3DCAPS2_CANCALIBRATEGAMMA      HEX: 00100000
CONSTANT: D3DCAPS2_RESERVED               HEX: 02000000
CONSTANT: D3DCAPS2_CANMANAGERESOURCE      HEX: 10000000
CONSTANT: D3DCAPS2_DYNAMICTEXTURES        HEX: 20000000
CONSTANT: D3DCAPS2_CANAUTOGENMIPMAP       HEX: 40000000

CONSTANT: D3DCAPS2_CANSHARERESOURCE       HEX: 80000000

CONSTANT: D3DCAPS3_RESERVED               HEX: 8000001f

CONSTANT: D3DCAPS3_ALPHA_FULLSCREEN_FLIP_OR_DISCARD   HEX: 00000020

CONSTANT: D3DCAPS3_LINEAR_TO_SRGB_PRESENTATION HEX: 00000080

CONSTANT: D3DCAPS3_COPY_TO_VIDMEM         HEX: 00000100
CONSTANT: D3DCAPS3_COPY_TO_SYSTEMMEM      HEX: 00000200
CONSTANT: D3DCAPS3_DXVAHD                 HEX: 00000400

CONSTANT: D3DPRESENT_INTERVAL_DEFAULT     HEX: 00000000
CONSTANT: D3DPRESENT_INTERVAL_ONE         HEX: 00000001
CONSTANT: D3DPRESENT_INTERVAL_TWO         HEX: 00000002
CONSTANT: D3DPRESENT_INTERVAL_THREE       HEX: 00000004
CONSTANT: D3DPRESENT_INTERVAL_FOUR        HEX: 00000008
CONSTANT: D3DPRESENT_INTERVAL_IMMEDIATE   HEX: 80000000

CONSTANT: D3DCURSORCAPS_COLOR             HEX: 00000001
CONSTANT: D3DCURSORCAPS_LOWRES            HEX: 00000002

CONSTANT: D3DDEVCAPS_EXECUTESYSTEMMEMORY  HEX: 00000010
CONSTANT: D3DDEVCAPS_EXECUTEVIDEOMEMORY   HEX: 00000020
CONSTANT: D3DDEVCAPS_TLVERTEXSYSTEMMEMORY HEX: 00000040
CONSTANT: D3DDEVCAPS_TLVERTEXVIDEOMEMORY  HEX: 00000080
CONSTANT: D3DDEVCAPS_TEXTURESYSTEMMEMORY  HEX: 00000100
CONSTANT: D3DDEVCAPS_TEXTUREVIDEOMEMORY   HEX: 00000200
CONSTANT: D3DDEVCAPS_DRAWPRIMTLVERTEX     HEX: 00000400
CONSTANT: D3DDEVCAPS_CANRENDERAFTERFLIP   HEX: 00000800
CONSTANT: D3DDEVCAPS_TEXTURENONLOCALVIDMEM HEX: 00001000
CONSTANT: D3DDEVCAPS_DRAWPRIMITIVES2      HEX: 00002000
CONSTANT: D3DDEVCAPS_SEPARATETEXTUREMEMORIES HEX: 00004000
CONSTANT: D3DDEVCAPS_DRAWPRIMITIVES2EX    HEX: 00008000
CONSTANT: D3DDEVCAPS_HWTRANSFORMANDLIGHT  HEX: 00010000
CONSTANT: D3DDEVCAPS_CANBLTSYSTONONLOCAL  HEX: 00020000
CONSTANT: D3DDEVCAPS_HWRASTERIZATION      HEX: 00080000
CONSTANT: D3DDEVCAPS_PUREDEVICE           HEX: 00100000
CONSTANT: D3DDEVCAPS_QUINTICRTPATCHES     HEX: 00200000
CONSTANT: D3DDEVCAPS_RTPATCHES            HEX: 00400000
CONSTANT: D3DDEVCAPS_RTPATCHHANDLEZERO    HEX: 00800000
CONSTANT: D3DDEVCAPS_NPATCHES             HEX: 01000000

CONSTANT: D3DPMISCCAPS_MASKZ              HEX: 00000002
CONSTANT: D3DPMISCCAPS_CULLNONE           HEX: 00000010
CONSTANT: D3DPMISCCAPS_CULLCW             HEX: 00000020
CONSTANT: D3DPMISCCAPS_CULLCCW            HEX: 00000040
CONSTANT: D3DPMISCCAPS_COLORWRITEENABLE   HEX: 00000080
CONSTANT: D3DPMISCCAPS_CLIPPLANESCALEDPOINTS HEX: 00000100
CONSTANT: D3DPMISCCAPS_CLIPTLVERTS        HEX: 00000200
CONSTANT: D3DPMISCCAPS_TSSARGTEMP         HEX: 00000400
CONSTANT: D3DPMISCCAPS_BLENDOP            HEX: 00000800
CONSTANT: D3DPMISCCAPS_NULLREFERENCE      HEX: 00001000
CONSTANT: D3DPMISCCAPS_INDEPENDENTWRITEMASKS     HEX: 00004000
CONSTANT: D3DPMISCCAPS_PERSTAGECONSTANT   HEX: 00008000
CONSTANT: D3DPMISCCAPS_FOGANDSPECULARALPHA   HEX: 00010000
CONSTANT: D3DPMISCCAPS_SEPARATEALPHABLEND         HEX: 00020000
CONSTANT: D3DPMISCCAPS_MRTINDEPENDENTBITDEPTHS    HEX: 00040000
CONSTANT: D3DPMISCCAPS_MRTPOSTPIXELSHADERBLENDING HEX: 00080000
CONSTANT: D3DPMISCCAPS_FOGVERTEXCLAMPED           HEX: 00100000

CONSTANT: D3DPMISCCAPS_POSTBLENDSRGBCONVERT       HEX: 00200000

CONSTANT: D3DLINECAPS_TEXTURE             HEX: 00000001
CONSTANT: D3DLINECAPS_ZTEST               HEX: 00000002
CONSTANT: D3DLINECAPS_BLEND               HEX: 00000004
CONSTANT: D3DLINECAPS_ALPHACMP            HEX: 00000008
CONSTANT: D3DLINECAPS_FOG                 HEX: 00000010
CONSTANT: D3DLINECAPS_ANTIALIAS           HEX: 00000020

CONSTANT: D3DPRASTERCAPS_DITHER                 HEX: 00000001
CONSTANT: D3DPRASTERCAPS_ZTEST                  HEX: 00000010
CONSTANT: D3DPRASTERCAPS_FOGVERTEX              HEX: 00000080
CONSTANT: D3DPRASTERCAPS_FOGTABLE               HEX: 00000100
CONSTANT: D3DPRASTERCAPS_MIPMAPLODBIAS          HEX: 00002000
CONSTANT: D3DPRASTERCAPS_ZBUFFERLESSHSR         HEX: 00008000
CONSTANT: D3DPRASTERCAPS_FOGRANGE               HEX: 00010000
CONSTANT: D3DPRASTERCAPS_ANISOTROPY             HEX: 00020000
CONSTANT: D3DPRASTERCAPS_WBUFFER                HEX: 00040000
CONSTANT: D3DPRASTERCAPS_WFOG                   HEX: 00100000
CONSTANT: D3DPRASTERCAPS_ZFOG                   HEX: 00200000
CONSTANT: D3DPRASTERCAPS_COLORPERSPECTIVE       HEX: 00400000
CONSTANT: D3DPRASTERCAPS_SCISSORTEST            HEX: 01000000
CONSTANT: D3DPRASTERCAPS_SLOPESCALEDEPTHBIAS    HEX: 02000000
CONSTANT: D3DPRASTERCAPS_DEPTHBIAS              HEX: 04000000 
CONSTANT: D3DPRASTERCAPS_MULTISAMPLE_TOGGLE     HEX: 08000000

CONSTANT: D3DPCMPCAPS_NEVER               HEX: 00000001
CONSTANT: D3DPCMPCAPS_LESS                HEX: 00000002
CONSTANT: D3DPCMPCAPS_EQUAL               HEX: 00000004
CONSTANT: D3DPCMPCAPS_LESSEQUAL           HEX: 00000008
CONSTANT: D3DPCMPCAPS_GREATER             HEX: 00000010
CONSTANT: D3DPCMPCAPS_NOTEQUAL            HEX: 00000020
CONSTANT: D3DPCMPCAPS_GREATEREQUAL        HEX: 00000040
CONSTANT: D3DPCMPCAPS_ALWAYS              HEX: 00000080

CONSTANT: D3DPBLENDCAPS_ZERO              HEX: 00000001
CONSTANT: D3DPBLENDCAPS_ONE               HEX: 00000002
CONSTANT: D3DPBLENDCAPS_SRCCOLOR          HEX: 00000004
CONSTANT: D3DPBLENDCAPS_INVSRCCOLOR       HEX: 00000008
CONSTANT: D3DPBLENDCAPS_SRCALPHA          HEX: 00000010
CONSTANT: D3DPBLENDCAPS_INVSRCALPHA       HEX: 00000020
CONSTANT: D3DPBLENDCAPS_DESTALPHA         HEX: 00000040
CONSTANT: D3DPBLENDCAPS_INVDESTALPHA      HEX: 00000080
CONSTANT: D3DPBLENDCAPS_DESTCOLOR         HEX: 00000100
CONSTANT: D3DPBLENDCAPS_INVDESTCOLOR      HEX: 00000200
CONSTANT: D3DPBLENDCAPS_SRCALPHASAT       HEX: 00000400
CONSTANT: D3DPBLENDCAPS_BOTHSRCALPHA      HEX: 00000800
CONSTANT: D3DPBLENDCAPS_BOTHINVSRCALPHA   HEX: 00001000
CONSTANT: D3DPBLENDCAPS_BLENDFACTOR       HEX: 00002000

CONSTANT: D3DPBLENDCAPS_SRCCOLOR2         HEX: 00004000
CONSTANT: D3DPBLENDCAPS_INVSRCCOLOR2      HEX: 00008000

CONSTANT: D3DPSHADECAPS_COLORGOURAUDRGB       HEX: 00000008
CONSTANT: D3DPSHADECAPS_SPECULARGOURAUDRGB    HEX: 00000200
CONSTANT: D3DPSHADECAPS_ALPHAGOURAUDBLEND     HEX: 00004000
CONSTANT: D3DPSHADECAPS_FOGGOURAUD            HEX: 00080000

CONSTANT: D3DPTEXTURECAPS_PERSPECTIVE         HEX: 00000001
CONSTANT: D3DPTEXTURECAPS_POW2                HEX: 00000002
CONSTANT: D3DPTEXTURECAPS_ALPHA               HEX: 00000004
CONSTANT: D3DPTEXTURECAPS_SQUAREONLY          HEX: 00000020
CONSTANT: D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE HEX: 00000040
CONSTANT: D3DPTEXTURECAPS_ALPHAPALETTE        HEX: 00000080

CONSTANT: D3DPTEXTURECAPS_NONPOW2CONDITIONAL  HEX: 00000100
CONSTANT: D3DPTEXTURECAPS_PROJECTED           HEX: 00000400
CONSTANT: D3DPTEXTURECAPS_CUBEMAP             HEX: 00000800
CONSTANT: D3DPTEXTURECAPS_VOLUMEMAP           HEX: 00002000
CONSTANT: D3DPTEXTURECAPS_MIPMAP              HEX: 00004000
CONSTANT: D3DPTEXTURECAPS_MIPVOLUMEMAP        HEX: 00008000
CONSTANT: D3DPTEXTURECAPS_MIPCUBEMAP          HEX: 00010000
CONSTANT: D3DPTEXTURECAPS_CUBEMAP_POW2        HEX: 00020000
CONSTANT: D3DPTEXTURECAPS_VOLUMEMAP_POW2      HEX: 00040000
CONSTANT: D3DPTEXTURECAPS_NOPROJECTEDBUMPENV  HEX: 00200000

CONSTANT: D3DPTFILTERCAPS_MINFPOINT           HEX: 00000100
CONSTANT: D3DPTFILTERCAPS_MINFLINEAR          HEX: 00000200
CONSTANT: D3DPTFILTERCAPS_MINFANISOTROPIC     HEX: 00000400
CONSTANT: D3DPTFILTERCAPS_MINFPYRAMIDALQUAD   HEX: 00000800
CONSTANT: D3DPTFILTERCAPS_MINFGAUSSIANQUAD    HEX: 00001000
CONSTANT: D3DPTFILTERCAPS_MIPFPOINT           HEX: 00010000
CONSTANT: D3DPTFILTERCAPS_MIPFLINEAR          HEX: 00020000

CONSTANT: D3DPTFILTERCAPS_CONVOLUTIONMONO     HEX: 00040000

CONSTANT: D3DPTFILTERCAPS_MAGFPOINT           HEX: 01000000
CONSTANT: D3DPTFILTERCAPS_MAGFLINEAR          HEX: 02000000
CONSTANT: D3DPTFILTERCAPS_MAGFANISOTROPIC     HEX: 04000000
CONSTANT: D3DPTFILTERCAPS_MAGFPYRAMIDALQUAD   HEX: 08000000
CONSTANT: D3DPTFILTERCAPS_MAGFGAUSSIANQUAD    HEX: 10000000

CONSTANT: D3DPTADDRESSCAPS_WRAP           HEX: 00000001
CONSTANT: D3DPTADDRESSCAPS_MIRROR         HEX: 00000002
CONSTANT: D3DPTADDRESSCAPS_CLAMP          HEX: 00000004
CONSTANT: D3DPTADDRESSCAPS_BORDER         HEX: 00000008
CONSTANT: D3DPTADDRESSCAPS_INDEPENDENTUV  HEX: 00000010
CONSTANT: D3DPTADDRESSCAPS_MIRRORONCE     HEX: 00000020

CONSTANT: D3DSTENCILCAPS_KEEP             HEX: 00000001
CONSTANT: D3DSTENCILCAPS_ZERO             HEX: 00000002
CONSTANT: D3DSTENCILCAPS_REPLACE          HEX: 00000004
CONSTANT: D3DSTENCILCAPS_INCRSAT          HEX: 00000008
CONSTANT: D3DSTENCILCAPS_DECRSAT          HEX: 00000010
CONSTANT: D3DSTENCILCAPS_INVERT           HEX: 00000020
CONSTANT: D3DSTENCILCAPS_INCR             HEX: 00000040
CONSTANT: D3DSTENCILCAPS_DECR             HEX: 00000080
CONSTANT: D3DSTENCILCAPS_TWOSIDED         HEX: 00000100

CONSTANT: D3DTEXOPCAPS_DISABLE                    HEX: 00000001
CONSTANT: D3DTEXOPCAPS_SELECTARG1                 HEX: 00000002
CONSTANT: D3DTEXOPCAPS_SELECTARG2                 HEX: 00000004
CONSTANT: D3DTEXOPCAPS_MODULATE                   HEX: 00000008
CONSTANT: D3DTEXOPCAPS_MODULATE2X                 HEX: 00000010
CONSTANT: D3DTEXOPCAPS_MODULATE4X                 HEX: 00000020
CONSTANT: D3DTEXOPCAPS_ADD                        HEX: 00000040
CONSTANT: D3DTEXOPCAPS_ADDSIGNED                  HEX: 00000080
CONSTANT: D3DTEXOPCAPS_ADDSIGNED2X                HEX: 00000100
CONSTANT: D3DTEXOPCAPS_SUBTRACT                   HEX: 00000200
CONSTANT: D3DTEXOPCAPS_ADDSMOOTH                  HEX: 00000400
CONSTANT: D3DTEXOPCAPS_BLENDDIFFUSEALPHA          HEX: 00000800
CONSTANT: D3DTEXOPCAPS_BLENDTEXTUREALPHA          HEX: 00001000
CONSTANT: D3DTEXOPCAPS_BLENDFACTORALPHA           HEX: 00002000
CONSTANT: D3DTEXOPCAPS_BLENDTEXTUREALPHAPM        HEX: 00004000
CONSTANT: D3DTEXOPCAPS_BLENDCURRENTALPHA          HEX: 00008000
CONSTANT: D3DTEXOPCAPS_PREMODULATE                HEX: 00010000
CONSTANT: D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR     HEX: 00020000
CONSTANT: D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA     HEX: 00040000
CONSTANT: D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR  HEX: 00080000
CONSTANT: D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA  HEX: 00100000
CONSTANT: D3DTEXOPCAPS_BUMPENVMAP                 HEX: 00200000
CONSTANT: D3DTEXOPCAPS_BUMPENVMAPLUMINANCE        HEX: 00400000
CONSTANT: D3DTEXOPCAPS_DOTPRODUCT3                HEX: 00800000
CONSTANT: D3DTEXOPCAPS_MULTIPLYADD                HEX: 01000000
CONSTANT: D3DTEXOPCAPS_LERP                       HEX: 02000000

CONSTANT: D3DFVFCAPS_TEXCOORDCOUNTMASK    HEX: 0000ffff
CONSTANT: D3DFVFCAPS_DONOTSTRIPELEMENTS   HEX: 00080000
CONSTANT: D3DFVFCAPS_PSIZE                HEX: 00100000

CONSTANT: D3DVTXPCAPS_TEXGEN              HEX: 00000001
CONSTANT: D3DVTXPCAPS_MATERIALSOURCE7     HEX: 00000002
CONSTANT: D3DVTXPCAPS_DIRECTIONALLIGHTS   HEX: 00000008
CONSTANT: D3DVTXPCAPS_POSITIONALLIGHTS    HEX: 00000010
CONSTANT: D3DVTXPCAPS_LOCALVIEWER         HEX: 00000020
CONSTANT: D3DVTXPCAPS_TWEENING            HEX: 00000040
CONSTANT: D3DVTXPCAPS_TEXGEN_SPHEREMAP    HEX: 00000100
CONSTANT: D3DVTXPCAPS_NO_TEXGEN_NONLOCALVIEWER   HEX: 00000200

CONSTANT: D3DDEVCAPS2_STREAMOFFSET                        HEX: 00000001
CONSTANT: D3DDEVCAPS2_DMAPNPATCH                          HEX: 00000002
CONSTANT: D3DDEVCAPS2_ADAPTIVETESSRTPATCH                 HEX: 00000004
CONSTANT: D3DDEVCAPS2_ADAPTIVETESSNPATCH                  HEX: 00000008
CONSTANT: D3DDEVCAPS2_CAN_STRETCHRECT_FROM_TEXTURES       HEX: 00000010
CONSTANT: D3DDEVCAPS2_PRESAMPLEDDMAPNPATCH                HEX: 00000020
CONSTANT: D3DDEVCAPS2_VERTEXELEMENTSCANSHARESTREAMOFFSET  HEX: 00000040

CONSTANT: D3DDTCAPS_UBYTE4     HEX: 00000001
CONSTANT: D3DDTCAPS_UBYTE4N    HEX: 00000002
CONSTANT: D3DDTCAPS_SHORT2N    HEX: 00000004
CONSTANT: D3DDTCAPS_SHORT4N    HEX: 00000008
CONSTANT: D3DDTCAPS_USHORT2N   HEX: 00000010
CONSTANT: D3DDTCAPS_USHORT4N   HEX: 00000020
CONSTANT: D3DDTCAPS_UDEC3      HEX: 00000040
CONSTANT: D3DDTCAPS_DEC3N      HEX: 00000080
CONSTANT: D3DDTCAPS_FLOAT16_2  HEX: 00000100
CONSTANT: D3DDTCAPS_FLOAT16_4  HEX: 00000200
