USING: alien.c-types alien.syntax classes.struct
windows.directx.dxgiformat windows.types ;
IN: windows.directx.dxgitype

CONSTANT: DXGI_STATUS_OCCLUDED HEX: 087a0001
CONSTANT: DXGI_STATUS_CLIPPED HEX: 087a0002
CONSTANT: DXGI_STATUS_NO_REDIRECTION HEX: 087a0004
CONSTANT: DXGI_STATUS_NO_DESKTOP_ACCESS HEX: 087a0005
CONSTANT: DXGI_STATUS_GRAPHICS_VIDPN_SOURCE_IN_USE HEX: 087a0006
CONSTANT: DXGI_STATUS_MODE_CHANGED HEX: 087a0007
CONSTANT: DXGI_STATUS_MODE_CHANGE_IN_PROGRESS HEX: 087a0008

CONSTANT: DXGI_ERROR_INVALID_CALL HEX: 887a0001
CONSTANT: DXGI_ERROR_NOT_FOUND HEX: 887a0002
CONSTANT: DXGI_ERROR_MORE_DATA HEX: 887a0003
CONSTANT: DXGI_ERROR_UNSUPPORTED HEX: 887a0004
CONSTANT: DXGI_ERROR_DEVICE_REMOVED HEX: 887a0005
CONSTANT: DXGI_ERROR_DEVICE_HUNG HEX: 887a0006
CONSTANT: DXGI_ERROR_DEVICE_RESET HEX: 887a0007
CONSTANT: DXGI_ERROR_WAS_STILL_DRAWING HEX: 887a000a
CONSTANT: DXGI_ERROR_FRAME_STATISTICS_DISJOINT HEX: 887a000b
CONSTANT: DXGI_ERROR_GRAPHICS_VIDPN_SOURCE_IN_USE HEX: 887a000c
CONSTANT: DXGI_ERROR_DRIVER_INTERNAL_ERROR HEX: 887a0020
CONSTANT: DXGI_ERROR_NONEXCLUSIVE HEX: 887a0021
CONSTANT: DXGI_ERROR_NOT_CURRENTLY_AVAILABLE HEX: 887a0022
CONSTANT: DXGI_ERROR_REMOTE_CLIENT_DISCONNECTED HEX: 887a0023
CONSTANT: DXGI_ERROR_REMOTE_OUTOFMEMORY HEX: 887a0024

STRUCT: DXGI_RGB
{ Red FLOAT }
{ Green FLOAT }
{ Blue FLOAT } ;

STRUCT: DXGI_GAMMA_CONTROL
{ Scale DXGI_RGB }
{ Offset DXGI_RGB }
{ GammaCurve DXGI_RGB[1025] } ;

STRUCT: DXGI_GAMMA_CONTROL_CAPABILITIES
{ ScaleAndOffsetSupported BOOL }
{ MaxConvertedValue FLOAT }
{ MinConvertedValue FLOAT }
{ NumGammaControlPoints UINT }
{ ControlPointPositions FLOAT[1025] } ;

STRUCT: DXGI_RATIONAL
{ Numerator UINT }
{ Denominator UINT } ;

C-ENUM: DXGI_MODE_SCANLINE_ORDER
    DXGI_MODE_SCANLINE_ORDER_UNSPECIFIED
    DXGI_MODE_SCANLINE_ORDER_PROGRESSIVE
    DXGI_MODE_SCANLINE_ORDER_UPPER_FIELD_FIRST
    DXGI_MODE_SCANLINE_ORDER_LOWER_FIELD_FIRST ;

C-ENUM: DXGI_MODE_SCALING
    DXGI_MODE_SCALING_UNSPECIFIED
    DXGI_MODE_SCALING_CENTERED
    DXGI_MODE_SCALING_STRETCHED ;

C-ENUM: DXGI_MODE_ROTATION
    DXGI_MODE_ROTATION_UNSPECIFIED
    DXGI_MODE_ROTATION_IDENTITY
    DXGI_MODE_ROTATION_ROTATE90
    DXGI_MODE_ROTATION_ROTATE180
    DXGI_MODE_ROTATION_ROTATE270 ;

STRUCT: DXGI_MODE_DESC
{ Width UINT }
{ Height UINT }
{ RefreshRate DXGI_RATIONAL }
{ Format DXGI_FORMAT }
{ ScanlineOrdering DXGI_MODE_SCANLINE_ORDER }
{ Scaling DXGI_MODE_SCALING } ;

STRUCT: DXGI_SAMPLE_DESC
{ Count UINT }
{ Quality UINT } ;
